# Copyright(c) 2002 Association of Universities for Research in Astronomy, Inc.

procedure garith(operand1, op, operand2, result)

# Simple arithmetic on MEF files tailored to GMOS
#
# Version  Feb 28, 2002  MT  v1.3 release

string  operand1	{prompt="Operand mef image"}
string  op        	{"",prompt="Operator", enum="+|-|*|/|min|max"}
string  operand2   	{prompt="Operand mef image or numerical constant"}
string  result    	{prompt="Output mef file"}
string  extension    	{"SCI",prompt="MEF extension name"}
int	status		{0,prompt="Exit status (0=good)"}

begin

string 	l_operand1, l_operand2, l_op, l_result, l_extension

string	imga, imgb, wmeffirst
string	tmp, img
int	ii, jj, numext
bool	itsanimageA, itsanimageB

# Make temp files
tmp = mktemp("tmp")

# Query parameters
l_operand1 = operand1 ; l_op = op; l_operand2 = operand2
l_result = result; l_extension = extension

gimverify(l_result)
if(gimverify.status==0 || gimverify.status==4) {
     print("ERROR - GARITH: Output image "//l_result//" already exists.")
     goto clean
}     

# Figure out if operand1 and 2 are images
itsanimageA=no; imga = l_operand1
gimverify(imga)
if(gimverify.status==0) {
     itsanimageA=yes
     wmeffirst=gimverify.outname//"[0]"
}

itsanimageB=no; imgb = l_operand2
gimverify(imgb)
if(gimverify.status==0) itsanimageB=yes

if(!itsanimageA && !itsanimageB) {
	printlog("ERROR - GARITH: both imputs are numbers","STDOUT",
		yes)
	goto clean
	status=1
}


# Get number of extensions
ii= 0; jj=0
if(itsanimageA){
        fxheader(l_operand1,format="",long-,count+, > tmp)
	tail(tmp,nlines=1) | scan(ii)
	delete(tmp,ver-)
	numext = ii
}
if(itsanimageB){
	fxheader(l_operand2,format="",long-,count+, > tmp)
	tail(tmp,nlines=1) | scan(jj)
	delete(tmp,ver-)
	numext=jj
}
# Check the number of extensions is the same in both images
if(itsanimageA && itsanimageB && ii!=jj) {
	printlog("ERROR - GARITH: Number of extensions in \
		input images is different","STDOUT",yes)
	status = 1
	goto clean
}

# Get the phu from the first image
if(!itsanimageA) wmeffirst=gimverify.outname//"[0]"
imcopy(wmeffirst,l_result//".fits",verbose-)

# Operate on each extension
for(ii=1; ii<=numext; ii+=1) {

	imgb = l_operand2
	if(itsanimageB) {
	  if(stridx("[",l_operand2)>0) {
	       imgb = substr(l_operand2,1,stridx("[",l_operand2)-1)//"["//ii//"]"	  
	       imgb = imgb//substr(l_operand2,stridx("[",l_operand2),strlen(l_operand2))
	  } else imgb = imgb//"["//ii//"]"
                
        }  
        
	imga = l_operand1
	if(itsanimageA) {
	  if(stridx("[",l_operand1)>0) {
	       imga = substr(l_operand1,1,stridx("[",l_operand1)-1)//"["//ii//"]"
	       imga = imga//substr(l_operand1,stridx("[",l_operand1),strlen(l_operand1))
	  } else imga = imga//"["//ii//"]"
                  
	}

	imarith(imga,l_op,imgb,l_result//"["//l_extension//","//ii//",append]",
               title="",divzero=0.,hparams="",pixtype="",calctype="",verbose-,
               noact-)		
}
    
     
clean:
delete(tmp,ver-, >& "dev$null")

end
