# Copyright(c) 2002 Association of Universities for Research in Astronomy, Inc.
#
# Package script for the quirc package
# load necessary packages - gemini loads most of the packages
gemtools

# spectroscopy packages for longslit - may be moved to gemini later
twodspec
longslit

package gmos

# mostools
set  mostools      = "gmos$mostools/"
task mostools.pkg  = mostools$mostools.cl

# Needed for IFU headers
set     min_lenuserarea = 200000

# generic tasks
task gdisplay=gmos$gdisplay.cl
task gprepare=gmos$gprepare.cl
task gbias=gmos$gbias.cl
task gbpm=gmos$gbpm.cl
task gmosaic=gmos$gmosaic.cl
task ggain=gmos$ggain.cl
# Simple MEF arithmetic task
task garith=gmos$garith.cl

#imaging tasks
task giflat=gmos$giflat.cl
task gireduce=gmos$gireduce.cl

#spectroscopy tasks
task gsappwave=gmos$gsappwave.cl
task gscalibrate=gmos$gscalibrate.cl
task gscut=gmos$gscut.cl
task gsextract=gmos$gsextract.cl
task gsflat=gmos$gsflat.cl
task gsreduce=gmos$gsreduce.cl
task gsskysub=gmos$gsskysub.cl
task gsstandard=gmos$gsstandard.cl
task gstransform=gmos$gstransform.cl
task gswavelength=gmos$gswavelength.cl

# cookbooks
task gmosinfo=gmos$gmosinfo.cl
task gmosinfoimag=gmos$gmosinfoimag.cl
task gmosinfospec=gmos$gmosinfospec.cl

# Examples
task gmosexamples=gmos$gmosexamples.cl

clbye()
